# - Find the CUDD_OBJ LP solver.
# This code defines the following variables:
#
#  CUDD_OBJ_FOUND                 - TRUE if CUDD_OBJ was found.
#  CUDD_OBJ_INCLUDE_DIRS          - Full paths to all include dirs.
#  CUDD_OBJ_LIBRARIES             - Full paths to all libraries.
#  CUDD_OBJ_RUNTIME_LIBRARY       - Full path to the dll file on windows
#
# Usage:
#  find_package(cplex)
#
# The location of CUDD_OBJ can be specified using the environment variable
# or cmake parameter DOWNWARD_CUDD_ROOT.
#
# Note that the standard FIND_PACKAGE features are supported
# (QUIET, REQUIRED, etc.).

find_path(CUDD_OBJ_INCLUDE_DIRS
    NAMES
    cuddObj.hh
    HINTS
    $ENV{DOWNWARD_CUDD_ROOT}
    ${DOWNWARD_CUDD_ROOT}
    ${CMAKE_CURRENT_SOURCE_DIR}/cudd-3.0.0
    PATH_SUFFIXES
    cplusplus
)

# set(CUDD_OBJ_LIBRARY_PATH_SUFFIX "cplusplus/.libs/")
# 
# find_library(CUDD_OBJ_LIBRARY_RELEASE
#     NAMES
#     obj
#     HINTS
#     $ENV{DOWNWARD_CUDD_ROOT}
#     ${DOWNWARD_CUDD_ROOT}
#     ${CMAKE_CURRENT_SOURCE_DIR}/cudd-3.0.0
#     PATH_SUFFIXES
#     ${CUDD_OBJ_LIBRARY_PATH_SUFFIX}
# )
# 
# find_library(CUDD_OBJ_LIBRARY_DEBUG
#     NAMES
#     obj
#     HINTS
#     $ENV{DOWNWARD_CUDD_ROOT}
#     ${DOWNWARD_CUDD_ROOT}
#     ${CMAKE_CURRENT_SOURCE_DIR}/cudd-3.0.0
#     PATH_SUFFIXES
#     ${CUDD_OBJ_LIBRARY_PATH_SUFFIX}
# )
# 
# if(CUDD_OBJ_LIBRARY_RELEASE OR CUDD_OBJ_LIBRARY_DEBUG)
#     set(CUDD_OBJ_LIBRARIES
#         optimized ${CUDD_OBJ_LIBRARY_RELEASE} ${CMAKE_THREAD_LIBS_INIT}
#         debug ${CUDD_OBJ_LIBRARY_DEBUG} ${CMAKE_THREAD_LIBS_INIT}
#     )
# endif()

# Check if everything was found and set CUDD_OBJ_FOUND.
include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(
    CuddObj
    REQUIRED_VARS CUDD_OBJ_INCLUDE_DIRS #CUDD_OBJ_LIBRARIES
)

mark_as_advanced(
    CUDD_OBJ_INCLUDE_DIRS CUDD_OBJ_LIBRARIES CUDD_OBJ_LIBRARY_PATH_SUFFIX
)
