#ifndef CEGAR_ADDITIVE_CARTESIAN_HEURISTIC_H
#define CEGAR_ADDITIVE_CARTESIAN_HEURISTIC_H

#include <vector>
#include <memory>

class TaskProxy;
class AbstractTask;

namespace utils {
    class RandomNumberGenerator;
}
namespace cegar{
    class RefinementHierarchy;
    
    bool disjunct(std::vector<bool> &v1, std::vector<bool> &v2);

    std::vector<std::vector<int>> sample_states_and_return_local_ids(
    const TaskProxy task_proxy, const std::shared_ptr<AbstractTask> abstract_task,
    const std::vector<std::shared_ptr<RefinementHierarchy>> &refinement_hierarchies,
    const std::vector<std::vector<int>> &h_values_by_abstraction_for_default_order,
    int init_h,
    int max_num_samples,
    double max_sampling_time,
    utils::RandomNumberGenerator &rng);


    void update_portfolio_h_values(std::vector<int> &portfolio_h_values,
                                   std::vector<int> &portfolio_h_values_improvement,
                                   const std::vector<std::vector<int>> &local_state_ids_by_state);
    

}
#endif
