#ifndef ADDITIVE_BACKWARD_HYPERABSTRACTION_HEURISTIC_H
#define ADDITIVE_BACKWARD_HYPERABSTRACTION_HEURISTIC_H

#include "hyperabstraction.h"
#include "hyperabstraction_generator.h"
#include "cost_partitioning_finder.h"
#include "../heuristic.h"

#include <vector>
#include <memory>

namespace hyperabstraction {

class AdditiveBackwardHyperabstractionHeuristic : public Heuristic {
public:
    AdditiveBackwardHyperabstractionHeuristic(const options::Options& opts);
    static void add_options_to_parser(options::OptionParser& parser);
protected:
    virtual int compute_heuristic(const GlobalState& state);

    const bool c_recompute_cost_partioning;

    std::shared_ptr<HyperabstractionGenerator> m_generator;
    std::shared_ptr<CostPartitioningFinder> m_cost_partitioning_finder;
    std::shared_ptr<LabeledHyperabstraction> m_abstraction;
    CostPartitioningCollection m_collection;
    std::vector<Node> m_source_nodes;
    std::vector<Node> m_sink_nodes;
};

}

#endif
