#ifndef ADDITIVE_FORWARD_HYPERABSTRACTION_HEURISTIC_H
#define ADDITIVE_FORWARD_HYPERABSTRACTION_HEURISTIC_H

#include "hyperabstraction.h"
#include "hyperabstraction_generator.h"
#include "cost_partitioning_finder.h"
#include "../heuristic.h"

#include <vector>
#include <memory>
#include <functional>

namespace hyperabstraction {

class AdditiveForwardHyperabstractionHeuristic : public Heuristic {
public:
    AdditiveForwardHyperabstractionHeuristic(const options::Options& opts);
    static void add_options_to_parser(options::OptionParser& parser);
protected:
    virtual int compute_heuristic(const GlobalState& state);

    std::shared_ptr<HyperabstractionGenerator> m_generator;
    CostPartitioningCollection m_collection;
    std::vector<Node> m_sink_nodes;
};

}

#endif
