#ifndef BACKWARD_HYPERABSTRACTION_HEURISTIC_H
#define BACKWARD_HYPERABSTRACTION_HEURISTIC_H

#include "hyperabstraction.h"
#include "hyperabstraction_generator.h"
#include "../heuristic.h"

#include <vector>
#include <memory>

namespace hyperabstraction {

class BackwardHyperabstractionHeuristic : public Heuristic {
public:
    BackwardHyperabstractionHeuristic(const options::Options& opts);
    static void add_options_to_parser(options::OptionParser& parser);
protected:
    virtual int compute_heuristic(const GlobalState& state) override;
private:
    std::shared_ptr<HyperabstractionGenerator> m_generator;
    std::shared_ptr<Hyperabstraction> m_abstraction;
    std::vector<Node> m_source_nodes;
    std::vector<Node> m_sink_nodes;
};

}

#endif
