#ifndef BIDIRECTIONAL_HYPERABSTRACTION_HEURISTIC_H
#define BIDIRECTIONAL_HYPERABSTRACTION_HEURISTIC_H

#include "../heuristic.h"
#include "hyperabstraction.h"
#include "hyperabstraction_generator.h"

namespace hyperabstraction {

class BidirectionalHyperabstractionHeuristic : public Heuristic {
public:
    BidirectionalHyperabstractionHeuristic(const options::Options& opts);
    static void add_options_to_parser(options::OptionParser& parser);
protected:
    virtual int compute_heuristic(const GlobalState& state) override;
private:
    std::shared_ptr<HyperabstractionGenerator> m_generator;
    std::shared_ptr<Hyperabstraction> m_fw_abstraction;
    std::shared_ptr<Hyperabstraction> m_bw_abstraction;
    std::vector<int> m_fw_distances;
    std::vector<Node> m_fw_init;
    std::vector<Node> m_bw_goal;
    std::vector<Node> m_state_nodes;
    unsigned m_num_actual_nodes;
};

}

#endif
