#ifndef CANONICAL_COST_PARTITIONING_FINDER_H
#define CANONICAL_COST_PARTITIONING_FINDER_H

#include "cost_partitioning_finder.h"

#include <vector>

namespace hyperabstraction {

class CanonicalCostPartitioningFinder : public CostPartitioningFinder {
public:
    CanonicalCostPartitioningFinder(const options::Options& opts);

    virtual CostPartitioningCollection compute_cost_partitioning(
        LabeledHyperabstraction& abstraction,
        const std::vector<Node>& source,
        const std::vector<Node>& sink) override;


    static void add_options_to_parser(options::OptionParser& parser);
protected:

    CostPartitioningCollection m_partitions;
};

}

#endif
