#ifndef CEGAR_COST_PARTITION_H
#define CEGAR_COST_PARTITION_H

#include "cost_partitioning_finder.h"

#include <vector>
#include <memory>

class AbstractTask;

namespace options {
    class Options;
    class OptionParser;
}

namespace hyperabstraction {

class CegarCostPartition : public CostPartitioningFinder {
    std::vector<CostPartitioning> cost_partitioning;

    static std::vector<CostPartitioning> compute_cegar_partitioning(
            const options::Options& opts,
            std::shared_ptr<AbstractTask> m_task);
public:
    CegarCostPartition(const options::Options& opts);

    static void add_options_to_parser(options::OptionParser& parser);
protected:
    virtual std::vector<CostPartitioning> compute_cost_partitioning(
        LabeledHyperabstraction& ,
        const std::vector<Node>& ,
        const std::vector<Node>& ) override {
        return cost_partitioning;
    }

};

}

#endif
