#ifndef COST_PARTITIONING_FINDER_H
#define COST_PARTITIONING_FINDER_H

#include "hyperabstraction.h"
#include "cost_partitioning.h"

#include <vector>
#include <memory>

class AbstractTask;

namespace options {
    class Options;
    class OptionParser;
}

namespace hyperabstraction {

class CostPartitioningFinder {
public:
    CostPartitioningFinder(const options::Options& opts);

    virtual CostPartitioningCollection compute_cost_partitioning(
        LabeledHyperabstraction& abstraction,
        const std::vector<Node>& source,
        const std::vector<Node>& sink) = 0;

    virtual int compute_cost_partitioning_and_get_distance(
        LabeledHyperabstraction& abstraction,
        const std::vector<Node>& source,
        const std::vector<Node>& sink);

    static void add_options_to_parser(options::OptionParser& parser);
protected:
    std::shared_ptr<AbstractTask> m_task;
};

}

#endif
