#ifndef FORWARD_HYPERABSTRACTION_HEURISTIC_H
#define FORWARD_HYPERABSTRACTION_HEURISTIC_H

#include "hyperabstraction.h"
#include "hyperabstraction_generator.h"
#include "../heuristic.h"

#include <vector>
#include <memory>

namespace hyperabstraction {

class ForwardHyperabstractionHeuristic : public Heuristic {
protected:
    std::shared_ptr<HyperabstractionGenerator> m_generator;
    std::vector<Node> m_satisfied_nodes;
    std::vector<int> m_distances;
    virtual int compute_heuristic(const GlobalState& state) override;
public:
    ForwardHyperabstractionHeuristic(const options::Options& opts);
    static void add_options_to_parser(options::OptionParser& parser);
};

}

#endif
