#ifndef GRAPH_CUT_COST_PARTITIONING_H
#define GRAPH_CUT_COST_PARTITIONING_H

#include "hyperabstraction.h"
#include "cost_partitioning_finder.h"

#include <vector>

namespace hyperabstraction {

class GraphCutCostPartitioning : public CostPartitioningFinder {
public:
    GraphCutCostPartitioning(const options::Options& opts);

    virtual std::vector<CostPartitioning> get_cost_partitioning(
        LabeledHyperabstraction& abstraction,
        const std::vector<Node>& source,
        const std::vector<Node>& sink) override;

    virtual int compute_cost_partitioning_and_get_distance(
        LabeledHyperabstraction& abstraction,
        const std::vector<Node>& source,
        const std::vector<Node>& sink) override;

    static void add_options_to_parser(options::OptionParser& parser);
protected:
    std::vector<int> m_default_cost;
    std::vector<std::pair<int, std::vector<int> > > m_cuts;
};

}

#endif
