#ifndef PATTERN_COLLECTION_GENERATOR_HYF_H
#define PATTERN_COLLECTION_GENERATOR_HYF_H

#include "pattern_generator.h"
#include "../utils/rng.h"

namespace options {
class Options;
class OptionParser;
}

namespace pdbs {

class PatternCollectionGeneratorHYF : public PatternCollectionGenerator {
public:
    PatternCollectionGeneratorHYF(const options::Options& opts);
    static void add_options_to_parser(options::OptionParser& parser);
protected:
    virtual PatternCollectionInformation generate_collection(
            std::shared_ptr<AbstractTask> task) override;
private:
    const unsigned c_goal_pdb_max_size;
    const unsigned c_pdb_max_size;
    const unsigned c_collection_max_size;
    const double c_split;
    const double c_max_time;
    utils::RandomNumberGenerator m_rng;
};


}

#endif
