#include "pattern_generator.h"

#include "../plugin.h"

namespace pdbs {

PatternCollectionGenerator::PatternCollectionGenerator()
    : cached_info(nullptr) {}

PatternCollectionInformation
PatternCollectionGenerator::generate(std::shared_ptr<AbstractTask> task)
{
    if (cached_info == nullptr) {
        cached_info = std::make_shared<PatternCollectionInformation>(
                generate_collection(task));
    }
    return *cached_info;
}

static PluginTypePlugin<PatternCollectionGenerator> _type_plugin_collection(
    "PatternCollectionGenerator",
    "Factory for pattern collections");

static PluginTypePlugin<PatternGenerator> _type_plugin_single(
    "PatternGenerator",
    "Factory for single patterns");
}
