#ifndef PDBS_PATTERN_GENERATOR_H
#define PDBS_PATTERN_GENERATOR_H

#include "pattern_collection_information.h"
#include "types.h"

#include <memory>

class AbstractTask;

namespace pdbs {
class PatternCollectionGenerator {
public:
    PatternCollectionGenerator();
    virtual ~PatternCollectionGenerator() = default;
    PatternCollectionInformation generate(std::shared_ptr<AbstractTask> task);
protected:
    virtual PatternCollectionInformation generate_collection(std::shared_ptr<AbstractTask> task) = 0;
private:
    std::shared_ptr<PatternCollectionInformation> cached_info;
};

class PatternGenerator {
public:
    virtual Pattern generate(std::shared_ptr<AbstractTask> task) = 0;
};
}

#endif
